//=============================================================================
// Change_KillersAttract_MZ.js
//   Last update: 2024/09/22
//=============================================================================
// 更新っぽいもの
// 
// 2024/09/22 [v0.1.0]
// 初版

/*:
 * @target MZ
 * 
 * @plugindesc
 * [v0.1.0] Change!! KillersAttract MZ.
 * 
 * @author Diamond
 *
 * @param KillersAttract Skill ID
 * @text ????
 * @default 170
 * @type skill
 * @desc
 * English is not supported.
 * Please Use Japanese!!
 * 
 * @help
 * Diamond use ruby, not use Java Script!!
 * Please use Ruby!! and RPG Tkool XP/VX/VX Ace.
 * 
 * @url https://diamond.iza-yoi.net/
 */

/*:ja
 * @target MZ
 * 
 * @plugindesc
 * [v0.1.0] 真（チェンジ！！）キラーズアトラクト MZ
 * 
 * @author 貪藻矢射妥←
 * 
 * @param KillersAttract Skill ID
 * @text 「キラーズアトラクト」のスキルID
 * @default 170
 * @type skill
 * @desc
 * 「キラーズアトラクト」のスキルID
 *
 * @help
 * セブンスドラゴンシリーズにあるアレです。
 * （敵と即エンカウントするスキル）
 *
 * Java ScriptよりもRubyを使いたい！ by 貪藻矢射妥←
 * 
 * @url https://diamond.iza-yoi.net/
 */

var OuterFlg = OuterFlg || {};

(() => {

OuterFlg.imported = OuterFlg.imported || {};
OuterFlg.imported['KillersAttract'] = true;

var pluginParams = PluginManager.parameters('Change_KillersAttract_MZ');
var changeKillersAttractSkillId     = Number(pluginParams['KillersAttract Skill ID'] || 170);

//-----------------------------------------------------------------------------
// Game_Player

Game_Player.prototype.killersAttract = function() {
    if (!$gameMap.isEventRunning()) {
        this.makeEncounterCount();
        const troopId = this.makeEncounterTroopId();
        if ($dataTroops[troopId]) {
            BattleManager.setup(troopId, true, false);
            BattleManager.onEncounter();
            return true;
        } else {
            return false;
        }
    } else {
        return false;
    }
};

Game_Player.prototype.makeEncounterNow = function() {
    this._encounterCount = 0;
};

//-----------------------------------------------------------------------------
// Scene_Skill

Scene_Skill.prototype.onItemOk = function() {
    if (this.item().id === changeKillersAttractSkillId) {
        // キラーズアトラクトの場合、バトルに突入できるか判断
        if ($gamePlayer.killersAttract()) {
            // Mapに戻って即時エンカウント
            $gamePlayer.makeEncounterNow();
            SceneManager.push(Scene_Map);
        } else {
            this.actor().setLastMenuSkill(this.item());
            // determineItem(); の代わりにブザーを鳴らし、ItemWindowをアクティベート
            SoundManager.playBuzzer();
            this.activateItemWindow();
        }
    } else{
        // キラーズアトラクト以外の場合は元の処理
        this.actor().setLastMenuSkill(this.item());
        this.determineItem();
    }
};



})();
